<?php
/**
 * @package Scheduler
 * @author DHTMLX LTD
 * @version 1.2
 */
/*
Plugin Name: Event Calendar / Scheduler
Plugin URI: http://wordpress.org/extend/plugins/event-calendar-scheduler/
Description: Events calendar that provides rich and intuitive scheduling solution
Author: DHTMLX LTD
Version: 1.2
Author URI: http://dhtmlx.com
*/

global $wpdb;

add_option('scheduler_table_name', 'events_rec');

add_option('scheduler_guest_view', 'on');
add_option('scheduler_subscriber_view', 'on');
add_option('scheduler_contributor_view', 'on');
add_option('scheduler_author_view', 'on');
add_option('scheduler_editor_view', 'on');
add_option('scheduler_admin_view', 'on');

add_option('scheduler_guest_add', 'off');
add_option('scheduler_subscriber_add', 'off');
add_option('scheduler_contributor_add', 'off');
add_option('scheduler_author_add', 'off');
add_option('scheduler_editor_add', 'off');
add_option('scheduler_admin_add', 'on');

add_option('scheduler_guest_edit', 'off');
add_option('scheduler_subscriber_edit', 'off');
add_option('scheduler_contributor_edit', 'off');
add_option('scheduler_author_edit', 'off');
add_option('scheduler_editor_edit', 'off');
add_option('scheduler_admin_edit', 'on');

add_option('scheduler_on_click', 'on');
add_option('scheduler_repeat', '0');
add_option('scheduler_12hr', '0');
add_option('scheduler_first_day', '0');
add_option('scheduler_edit_guest', '0');
add_option('scheduler_edit_reg', '1');
add_option('scheduler_edit_adm', '1');
add_option('scheduler_width', '100%');
add_option('scheduler_height', '400px');
add_option('scheduler_day', '');
add_option('scheduler_week', '');
add_option('scheduler_month', 'on');
add_option('scheduler_year', '');
add_option('scheduler_agenda', 'on');
add_option('scheduler_default', 'month');
add_option('scheduler_posts', '0');
add_option('scheduler_version', '1.1');
add_option('scheduler_started', '0');
add_option('scheduler_sidebar', '5');
add_option('scheduler_url', '');
add_option('scheduler_multiline', '0');

$usertypes = Array(0 => 'subscriber', 1 => 'contributor', 2 => 'author', 3 => 'editor', 4 => 'editor', 5 => 'editor', 6 => 'editor', 7 => 'editor', 8 => 'admin', 9 => 'admin', 10 => 'admin');

$table_name = 'events_rec';
if (get_option('scheduler_started') == '0') {
	$sql = "CREATE TABLE IF NOT EXISTS `". $table_name ."` (
	  `event_id` int(11) NOT NULL AUTO_INCREMENT,
	  `start_date` datetime NOT NULL,
	  `end_date` datetime NOT NULL,
	  `text` varchar(255) NOT NULL,
	  `rec_type` varchar(64) NOT NULL,
	  `event_pid` int(11) NOT NULL,
	  `event_length` int(11) NOT NULL,
	  PRIMARY KEY (`event_id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";

	
	$result = $wpdb->query($sql);

	$insert = "INSERT INTO " . $table_name .
		" (`start_date`, `end_date`, `text`, `event_pid`, `event_length`) VALUES ".
		"(NOW(), DATE_ADD(NOW(), INTERVAL 5 MINUTE), 'The Scheduler Calendar was installed!', 0, 0);";
	$wpdb->query($insert);
	
	$query = "ALTER TABLE `events_rec` CHANGE `text` `text` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ;";
	$wpdb->query($query);
	$query = "ALTER TABLE `events_rec` CHANGE `rec_type` `rec_type` VARCHAR( 64 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL  ;";
	$wpdb->query($query);
	$query = "ALTER TABLE `events_rec`  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;";
	$wpdb->query($query);
	
	update_option('scheduler_started', '1');
}

if (get_option('scheduler_url') == '') {
	$url_query = "SELECT `guid` FROM `".$table_prefix."posts` WHERE `post_title`='scheduler-calendar'";
	$url = $wpdb->get_var($url_query);

	if (!$url) {
		$page_number = "SELECT MAX(`ID`) FROM `".$table_prefix."posts`";
		$page_number = $wpdb->get_var($page_number);
		$insert = "INSERT INTO `".$table_prefix."posts` (`ID`, `post_author`, `post_date`, `post_date_gmt`, `post_content`, `post_title`, `post_excerpt`, `post_status`, `comment_status`, `ping_status`, `post_password`, `post_name`, `to_ping`, `pinged`, `post_modified`, `post_modified_gmt`, `post_content_filtered`, `post_parent`, `guid`, `menu_order`, `post_type`, `post_mime_type`, `comment_count`) VALUES
				(".($page_number + 1).", 1, '".date("Y-m-d H:i:s")."', '0000-00-00 00:00:00', '[[scheduler_plugin]]', 'scheduler-calendar', '', 'publish', 'closed', 'closed', '', '', '', '', '".date("Y-m-d H:i:s")."', '".date("Y-m-d H:i:s")."', '', 0, '".get_option('siteurl')."/?page_id=".($page_number+1)."', 0, 'page', '', 0)";
		$wpdb->query($insert);
	}
	$url_query = "SELECT `guid` FROM `".$table_prefix."posts` WHERE `post_title`='scheduler-calendar'";
	$url = $wpdb->get_var($url_query);
	update_option('scheduler_url', $url);
}


$locale = WPLANG;
$loc = substr($locale, 0, 2);


$local = ABSPATH.'wp-content/plugins/event-calendar-scheduler/codebase/sources/'.$loc.'.php';
if (file_exists($local)) {
	include($local);
} else {
	$local = ABSPATH.'wp-content/plugins/event-calendar-scheduler/codebase/sources/en.php';
	include($local);
}


function scheduler_add_pages() {
	global $lang;
	add_submenu_page('plugins.php', $lang['_SCHEDULER_menu'], $lang['_SCHEDULER_menu'], 8, 'Scheduler settings3', 'scheduler_settings');
}


function scheduler_settings() {
	global $lang;
	global $current_user;

	$width = get_option('scheduler_width');
	if ((strpos($width, "%") == 0)&&((strpos($width, "px") == 0))) {
		$width.= "px";
	}
	preg_match("/\d*/", $width, $temp);
	$temp = (int) $temp[0];
	if (strpos($width, "%")) {
		if ($temp < 20) {
			$width = '100%';
			}
		} else {
		if ($temp < 200) {
			$width = '500px';
		}
	}
	if (preg_match("/[^0-9px%]/", $width)) {
		$width = '500px';
	}
	update_option('scheduler_width', $width);

	$height = get_option('scheduler_height');
	if (strpos($height, "%") != 0) {
		$height = "400px";
	}
	if (strpos($height, "px") == 0) {
		$height.= "px";
	}
	preg_match("/\d*/", $height, $temp);
	$temp = (int) $temp[0];
	if ($temp < 200) {
		$height = '500px';
	}	
	if (preg_match("/[^0-9px]/", $height)) {
		$height = '400px';
	}
	update_option('scheduler_height', $height);

	if (get_option('scheduler_posts') == 'on') {
		update_option("scheduler_default", "month");
	}

	include(ABSPATH.'wp-content\plugins\event-calendar-scheduler\admin.php');
}


function scheduler_init() {
	global $current_user, $user_ID, $loc, $lang, $usertypes;
	$tabsOffset = 20;
	get_currentuserinfo();
	$userlevel = $current_user->user_level;
		if (isset($usertypes[$userlevel])) {
			$userlevel = $usertypes[$userlevel];
		} else {
			$userlevel = 'guest';
		}
	if ((get_option('scheduler_day') == '')&&(get_option('scheduler_week') == '')&&(get_option('scheduler_month') == '')&&(get_option('scheduler_posts') == '')&&
		(get_option('scheduler_year') == '')&&(get_option('scheduler_agenda') == '')) {
		return $lang['_SCHEDULER_tabs_warning'];
	}
	if (get_option("scheduler_".$userlevel."_view") != 'on') {
		return '';
	}
	include(ABSPATH.'wp-content\plugins\event-calendar-scheduler\scheduler_init.php');
		
	return $final;
}


function scheduler_sidebar() {
	global $wpdb, $table_prefix, $lang, $current_user, $userTypes;

	
	get_currentuserinfo();
	$userlevel = $current_user->user_level;
	if (isset($usertypes[$userlevel])) {
		$userlevel = $usertypes[$userlevel];
	} else {
		$userlevel = 'guest';
	}

	if (get_option("scheduler_".$userlevel."_view") != 'on') {
		return '';
	}
	
	include(ABSPATH.'wp-content\plugins\event-calendar-scheduler\sidebar.php');

	$query = "SELECT `start_date`, `text` FROM `".get_option('scheduler_table_name')."` WHERE `rec_type`='' AND `event_pid`='0' AND `end_date` > NOW() LIMIT 0, ".get_option('scheduler_sidebar');
	$events = $wpdb->get_results($query);
	$url = get_option('scheduler_url');

	$final = str_replace("{*NAME*}", $lang['_SCHEDULER_sidebar_header'], $sidebarHeader);//'<div class="scheduler_sidebar_header"><h3>'.$lang['_SCHEDULER_sidebar_header'].'</h3></div>';
	if (count($events) == 0) {
		$final = '';
	}
	
	for ($i = 0; $i < count($events); $i++) {
		$event = $sidebarEvent;
		$start_date = str_replace("-", "/", $events[$i]->start_date);
		$start_date = date_parse($events[$i]->start_date);
		$start_date = mktime($start_date['hour'], $start_date['minute'], $start_date['second'], $start_date['month'], $start_date['day'], $start_date['year']);
		$start_date = date(get_option('date_format').' '.get_option('time_format'), $start_date);
		$event = str_replace("{*URL*}", $url, $event);
		$event = str_replace("{*DATE*}", $start_date, $event);
		$event = str_replace("{*DATE_SQL*}", $events[$i]->start_date, $event);
		$event = str_replace("{*TEXT*}", $events[$i]->text, $event);
		$final .= $event;
	}

	return $final;
}


function scheduler_check($content) {
	global $lang;
	$ver = phpversion();
	$ver_main = (int) substr($ver, 0, 1);
	if ( $ver_main < 5) {
		return $lang['_SCHEDULER_version_error'];
		}

	if (strpos($content, "[[scheduler_plugin]]") !== FALSE)  {
		$content = preg_replace('/<p>\s*\[\[(.*)\]\]\s*<\/p>/i', "[[$1]]", $content);
		$content = preg_replace('/\[\[scheduler_plugin\]\]/Ui', scheduler_init(), $content, 1);
		$content = str_replace('[[scheduler_plugin]]', '', $content);
	}
	if (strpos($content, "[[scheduler_sidebar]]")) {
		$content = preg_replace('/<p>\s*\[\[(.*)\]\]\s*<\/p>/i', "[[$1]]", $content);
		$content = str_replace('[[scheduler_sidebar]]', scheduler_sidebar(), $content);
	}
	return $content;
}


function scheduler_addbuttons() {
	global $current_user, $usertypes;
	get_currentuserinfo();
	$userlevel = $current_user->user_level;

	if (isset($usertypes[$userlevel])) {
		$userlevel = $usertypes[$userlevel];
	} else {
		$userlevel = 'guest';
	}

	if ((!current_user_can('edit_posts') && ! current_user_can('edit_pages'))||(get_option("scheduler_".$userlevel."_add") != 'on')) {
		return;
	}

	if ( get_user_option('rich_editing') == 'true') {
		add_filter("mce_external_plugins", "add_scheduler_tinymce_plugin");
		add_filter('mce_buttons', 'register_scheduler_button');
	}
}


function register_scheduler_button($buttons) {
	array_push($buttons, "separator", "scheduler");
	return $buttons;
}


function add_scheduler_tinymce_plugin($plugin_array) {
	$plugin_array['scheduler'] = WP_PLUGIN_URL.'/event-calendar-scheduler/mce_scheduler/editor_plugin.js';
	return $plugin_array;
}


add_action('admin_menu', 'scheduler_add_pages');
add_action('init', 'scheduler_addbuttons');
add_filter('the_content', 'scheduler_check');



?>